/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/08/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AKHIR_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AWAL_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.VARCHAR;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.Type;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import lombok.Setter;
@Entity
@Table(name = "JenisProfile_M",indexes = {@Index(name = "JenisProfile_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class JenisProfile {

	private static final String cDefKdJenisProfile = INTEGER;
	@Column(name = "KdJenisProfile", columnDefinition = cDefKdJenisProfile)
    @Id
    @GeneratedValue
	private Integer kdJenisProfile;

	private static final String cDefKdJenisProfileHead = INTEGER;
	@Column(name = "KdJenisProfileHead", columnDefinition = cDefKdJenisProfileHead)
	private Integer kdJenisProfileHead;

	private static final String cDefJenisProfile = VARCHAR + AWAL_KURUNG + 30 + AKHIR_KURUNG;
	@Column(name = "JenisProfile", columnDefinition = cDefJenisProfile)
	@NotNull(message = "jenisprofile.jenisprofile.notnull")
	private String namaJenisProfile;

    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 15 + AKHIR_KURUNG;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;

    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 30 + AKHIR_KURUNG;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;

    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 20 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "jenisprofile.reportdisplay.notnull")
    private String reportDisplay;

    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "jenisprofile.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;

    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "jenisprofile.norec.notnull")
    private String noRec;

    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "jenisprofile.version.notnull")
    private Integer version;

}


